/*
Application for Arduino Matrix
can be used with Arduino hardware

code by www.circuitdigest.com
coded on 25-05-2017
*/

int led_dia = (width/height)*70;
Led[] led_array; //Object Array declaration # Led led1; //Object declaration

//**Import the necessary header files**//
import android.content.Intent;
import android.os.Bundle;
import ketai.net.bluetooth.*;
import ketai.ui.*;
import ketai.net.*;
import android.bluetooth.BluetoothAdapter;
import android.view.KeyEvent;
//__End of imports__//
BluetoothAdapter bluetooth = BluetoothAdapter.getDefaultAdapter();

PImage needle, speedval, speedcover, neon, gloss,logo;
KetaiBluetooth bt;
int info,speed;
int data, i;
String cninfo = "";
String temp_info;
float angle;
boolean send_flag=true;
boolean click_flag=true;
int color_val;
boolean red = true;
color led_color = color(255,255,255);
int load;


//**To start BT when app is launched**// 
void onCreate(Bundle savedInstanceState) {
 super.onCreate(savedInstanceState);
 bt = new KetaiBluetooth(this);
}
void onActivityResult(int requestCode, int resultCode, Intent data) {
  bt.onActivityResult(requestCode, resultCode, data);
}
//__BT launched__//


//**To select bluetooth device if needed**// (not required for our program
void onKetaiListSelection(KetaiList klist)
{
 String selection = klist.getSelection();
 bt.connectToDeviceByName(selection);
 //dispose of list for now
 klist = null;
}
//__End of selection__//


//** To get data from blue tooth**/
void onBluetoothDataEvent(String who, byte[] data)
{
info = (data[0] & 0xFF) ;
}
//__data received_//


//**To get connection status**//
String getBluetoothInformation()
{
  String btInfo = "Connected to :";

  ArrayList<String> devices = bt.getConnectedDeviceNames();
  for (String device: devices)
  {
    btInfo+= device+"\n";
  }

  return btInfo;
}
//--connection status received_//


//**Settings for the Android Application**//
void settings()
{
 fullScreen(); //make the app for in full screen 
}
//__Settings completed__//


//**Executes only once**// (similar to arduino)
void setup() 
{
  textSize(led_dia);
  bt.start(); //start listening for BT connections
  bt.getPairedDeviceNames();
  bt.connectToDeviceByName("HC-06"); //Connect to our HC-06 bluetooth module
  
 load_leds(); //load all led in position and colour
  
//**Load all images from data file**//

  logo = loadImage("logo.png");
//End of loading images**//

}

void load_buttons()
{
  rectMode(CENTER);
  textAlign(CENTER,CENTER);
  noStroke();
  fill(#1BF2D4); 
  rect(width/2-width/4,height/1.3,width/4,height/12); fill(0); text("Reset",width/2-width/4,height/1.3); //button 1

  if (red==true)
  {  fill(#080F89); rect(width/2+width/4,height/1.3,width/4,height/12);fill(255,0,0); text("RED",width/2+width/4,height/1.3);} //button 2
  if (red==false)
  {fill(#080F89); rect(width/2+width/4,height/1.3,width/4,height/12);fill(255); text("WHITE",width/2+width/4,height/1.3);} //button 2
}

void read_buttons()
{
    if (mousePressed && click_flag==true) 
  {
  color_val = get(mouseX, mouseY);
  click_flag=false;
  if (color_val==-14945580)
  {
   byte[] data = {0};
   bt.broadcast(data);
   println("RESET");load_leds(); //load all led in position and colour
  }
   
  if (color_val==-16248951)
  {
   byte[] data = {100};
   bt.broadcast(data);
   if (red == true)
   red = false;
   else if (red == false)
   red = true;
  
   println("TOGGLE");
   }
  
  color_val=0;
  }
  
}


void mouseReleased()
{
  click_flag=true;
}

//**Draw function**//
void draw() //The infinite loop
{
 background(0);
 load_buttons();
 read_buttons();
  
 imageMode(CENTER);
 image(logo, width/2, height/1.04, width, height/12);

//dipslay all leds
for (int i=1; i<=64; i++)
  led_array[i].display();
  //All leds displayed

if (red == true)
{led_color = color(255,0,0);}
if (red==false)
{led_color = color(255,255,255);}


//check if mouse over led //If yes send the led number
for (int i=1; i<=64; i++)
{
  if( (mouseX < (led_array[i].X_Pos + led_dia/2)) && (mouseX > (led_array[i].X_Pos - led_dia/2)) && (mouseY < (led_array[i].Y_Pos + led_dia/2))  && (mouseY > (led_array[i].Y_Pos - led_dia/2)))
  {led_array[i] = new Led(led_array[i].X_Pos, led_array[i].Y_Pos, led_color); 
  byte[] data = {byte(i)};
  bt.broadcast(data);
  }
}

//println(led_array[1].X_Pos);
//println(mouseX);
 
  textfun();
  getval();

}
///__End of draw__//

void textfun()
{ 
  textSize(30);
  textAlign(CENTER);
  fill(255);
  cninfo = getBluetoothInformation();    //get connection information status
  text(cninfo,width/2,height-height/1.03);
  noFill();
}


void load_leds(){
      
  led_array = new Led[65];
  int a=1;
  
  for (int j=0; j<=7; j++){
    float y = height/6 + j*(led_dia*1.5);
  for (int i=0; i<=7; i++)
  {
    float x = (width/6) + i*(led_dia*1.5); //fill(255);
    //ellipse(x, y, led_dia, led_dia);
    led_array[a] = new Led(x,y,color(255,255,255));
    a++;
  }
  } 
}



class Led{
  
  float X_Pos;
  float Y_Pos;
  color colour;
  
  //CONSTRUTOR
  Led (float tempx, float tempy, color tempc){
    X_Pos = tempx;
    Y_Pos = tempy;
    colour = tempc;
  } 
  void display()
  {
    fill(colour);
    ellipse(X_Pos, Y_Pos, led_dia, led_dia);
  } 
}
